/*
 * WebApiSegura Token JWT XrmAPI
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;
import io.swagger.client.BuildParameters;
import io.swagger.client.WebserviceParameters;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.AttachmentData;
import io.swagger.client.model.CSeguimientoContratacionPortalAttributes;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SeguimientoContratacionPortalApi {
    private ApiClient apiClient;
	static final String AUTH_TEXT="Authorization";
	static final String ACCEPTTEXT="Accept";
	static final String CONTENTTYPE="Content-Type";
	static final String APIMETHOD="/api/seguimientocontratacionportal/";
	static final String APIMETHODSLASH="/api/seguimientocontratacionportal";
	
	static final String APPJSON="application/json";
	static final String TEXTJSON="text/json";
	static final String TEXT_XML="text/xml";
	static final String URLENCODE="application/x-www-form-urlencoded";

    public SeguimientoContratacionPortalApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SeguimientoContratacionPortalApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for seguimientoContratacionPortalClearcache
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalClearcacheCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody12 = null;

        
        String localVarPath12 = APIMETHOD + "clearcache";

        List<Pair> localVarQueryParams12 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams12 = new ArrayList<>();

        Map<String, String> localVarHeaderParams12 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams12.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams12 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams12.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams12.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames12 = new String[] {  };
        BuildParameters buildParameters12=new BuildParameters();
			buildParameters12.setPath(localVarPath12);
			buildParameters12.setMethod("GET");
			buildParameters12.setQueryParams(localVarQueryParams12);
			buildParameters12.setCollectionQueryParams(localVarCollectionQueryParams12);
			buildParameters12.setBody(localVarPostBody12);
			buildParameters12.setHeaderParams(localVarHeaderParams12);
			buildParameters12.setFormParams(localVarFormParams12);
			buildParameters12.setAuthNames(localVarAuthNames12);
			buildParameters12.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters12);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalClearcacheValidateBeforeCall(String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return seguimientoContratacionPortalClearcacheCall(authorization, progressListener, progressRequestListener);        
    }
    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalClearcache(String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalClearcacheWithHttpInfo(authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalClearcacheWithHttpInfo(String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalClearcacheValidateBeforeCall(authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    
    /**
     * Build call for seguimientoContratacionPortalDelete
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalDeleteCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody22 = null;

        
        String localVarPath22 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams22 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams22 = new ArrayList<>();
        if (statecode != null){
			localVarQueryParams22.addAll(apiClient.parameterToPair("statecode", statecode));
		}
        if (statuscode != null){
			localVarQueryParams22.addAll(apiClient.parameterToPair("statuscode", statuscode));
		}

        Map<String, String> localVarHeaderParams22 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams22.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams22 = new HashMap<>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams22.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams22.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames22 = new String[] {  };
        BuildParameters buildParameters22=new BuildParameters();
			buildParameters22.setPath(localVarPath22);
			buildParameters22.setMethod("DELETE");
			buildParameters22.setQueryParams(localVarQueryParams22);
			buildParameters22.setCollectionQueryParams(localVarCollectionQueryParams22);
			buildParameters22.setBody(localVarPostBody22);
			buildParameters22.setHeaderParams(localVarHeaderParams22);
			buildParameters22.setFormParams(localVarFormParams22);
			buildParameters22.setAuthNames(localVarAuthNames22);
			buildParameters22.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters22);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalDeleteValidateBeforeCall(String id, String statecode, String statuscode, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling seguimientoContratacionPortalDelete(Async)");
        }
        return seguimientoContratacionPortalDeleteCall(id, statecode, statuscode, authorization, progressListener, progressRequestListener);        

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void seguimientoContratacionPortalDelete(String id, String statecode, String statuscode, String authorization) throws ApiException {
        seguimientoContratacionPortalDeleteWithHttpInfo(id, statecode, statuscode, authorization);
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param statecode  (optional)
     * @param statuscode  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> seguimientoContratacionPortalDeleteWithHttpInfo(String id, String statecode, String statuscode, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalDeleteValidateBeforeCall(id, statecode, statuscode, authorization, null, null);
        return apiClient.execute(call);
    }
	/**
     * Build call for seguimientoContratacionPortalDeleteFile
     * @param filename  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalDeleteFileCall(String filename, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody32 = null;

        
        String localVarPath32 = APIMETHOD + "deletefile";

        List<Pair> localVarQueryParams32 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams32 = new ArrayList<>();
        if (filename != null){
			localVarQueryParams32.addAll(apiClient.parameterToPair("filename", filename));
		}

        Map<String, String> localVarHeaderParams32 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams32.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams32 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams32.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams32.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames32 = new String[] {  };
        BuildParameters buildParameters32=new BuildParameters();
			buildParameters32.setPath(localVarPath32);
			buildParameters32.setMethod("POST");
			buildParameters32.setQueryParams(localVarQueryParams32);
			buildParameters32.setCollectionQueryParams(localVarCollectionQueryParams32);
			buildParameters32.setBody(localVarPostBody32);
			buildParameters32.setHeaderParams(localVarHeaderParams32);
			buildParameters32.setFormParams(localVarFormParams32);
			buildParameters32.setAuthNames(localVarAuthNames32);
			buildParameters32.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters32);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalDeleteFileValidateBeforeCall(String filename, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        if (filename == null) {
            throw new ApiException("Missing the required parameter 'filename' when calling seguimientoContratacionPortalDeleteFile(Async)");
        }        
        return seguimientoContratacionPortalDeleteFileCall(filename, authorization, progressListener, progressRequestListener);
    }

    /**
     * 
     * 
     * @param filename  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalDeleteFile(String filename, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalDeleteFileWithHttpInfo(filename, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param filename  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalDeleteFileWithHttpInfo(String filename, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalDeleteFileValidateBeforeCall(filename, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

	/**
     * Build call for seguimientoContratacionPortalGet
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalGetCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody42 = null;

        
        String localVarPath42 = APIMETHOD + "get";

        List<Pair> localVarQueryParams42 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams42 = new ArrayList<>();
        if (webserviceParameters.getIndex() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("index", webserviceParameters.getIndex()));
		}
        if (webserviceParameters.getLimit() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("limit", webserviceParameters.getLimit()));
		}
        if (webserviceParameters.getQ() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("q", webserviceParameters.getQ()));
		}
        if (webserviceParameters.getOrderby() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("orderby", webserviceParameters.getOrderby()));
		}
        if (webserviceParameters.getOrder() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("order", webserviceParameters.getOrder()));
		}
        if (webserviceParameters.getFields() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("fields", webserviceParameters.getFields()));
		}
        if (webserviceParameters.getFilters() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("filters", webserviceParameters.getFilters()));
		}
        if (webserviceParameters.getFetchcount() != null){
			localVarQueryParams42.addAll(apiClient.parameterToPair("fetchcount", webserviceParameters.getFetchcount()));
		}
        Map<String, String> localVarHeaderParams42 = new HashMap<>();
		if (authorization != null){
			localVarHeaderParams42.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams42 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams42.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams42.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames42 = new String[] {  };
        BuildParameters buildParameters42=new BuildParameters();
			buildParameters42.setPath(localVarPath42);
			buildParameters42.setMethod("GET");
			buildParameters42.setQueryParams(localVarQueryParams42);
			buildParameters42.setCollectionQueryParams(localVarCollectionQueryParams42);
			buildParameters42.setBody(localVarPostBody42);
			buildParameters42.setHeaderParams(localVarHeaderParams42);
			buildParameters42.setFormParams(localVarFormParams42);
			buildParameters42.setAuthNames(localVarAuthNames42);
			buildParameters42.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters42);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalGetValidateBeforeCall(WebserviceParameters webserviceParameters, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        return seguimientoContratacionPortalGetCall(webserviceParameters, authorization, progressListener, progressRequestListener);
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalGet(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalGetWithHttpInfo(webserviceParameters, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param index  (optional)
     * @param limit  (optional)
     * @param q  (optional)
     * @param orderby  (optional)
     * @param order  (optional)
     * @param fields  (optional)
     * @param filters  (optional)
     * @param fetchcount  (optional)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalGetWithHttpInfo(WebserviceParameters webserviceParameters, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalGetValidateBeforeCall(webserviceParameters, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

	/**
     * Build call for seguimientoContratacionPortalGet0
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalGet0Call(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody52 = null;

        
        String localVarPath52 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams52 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams52 = new ArrayList<>();

        Map<String, String> localVarHeaderParams52 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams52.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams52 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams52.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams52.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames52 = new String[] {  };
        BuildParameters buildParameters52=new BuildParameters();
			buildParameters52.setPath(localVarPath52);
			buildParameters52.setMethod("GET");
			buildParameters52.setQueryParams(localVarQueryParams52);
			buildParameters52.setCollectionQueryParams(localVarCollectionQueryParams52);
			buildParameters52.setBody(localVarPostBody52);
			buildParameters52.setHeaderParams(localVarHeaderParams52);
			buildParameters52.setFormParams(localVarFormParams52);
			buildParameters52.setAuthNames(localVarAuthNames52);
			buildParameters52.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters52);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalGet0ValidateBeforeCall(String id, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
       
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling seguimientoContratacionPortalGet0(Async)");
        }
        return seguimientoContratacionPortalGet0Call(id, authorization, progressListener, progressRequestListener);
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalGet0(String id, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalGet0WithHttpInfo(id, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalGet0WithHttpInfo(String id, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalGet0ValidateBeforeCall(id, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }
	/**
     * Build call for seguimientoContratacionPortalPost
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalPostCall(CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody62 = value;

        
        String localVarPath62 = APIMETHODSLASH;

        List<Pair> localVarQueryParams62 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams62 = new ArrayList<>();

        Map<String, String> localVarHeaderParams62 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams62.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams62 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams62.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams62.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames62 = new String[] {  };
        BuildParameters buildParameters62=new BuildParameters();
			buildParameters62.setPath(localVarPath62);
			buildParameters62.setMethod("POST");
			buildParameters62.setQueryParams(localVarQueryParams62);
			buildParameters62.setCollectionQueryParams(localVarCollectionQueryParams62);
			buildParameters62.setBody(localVarPostBody62);
			buildParameters62.setHeaderParams(localVarHeaderParams62);
			buildParameters62.setFormParams(localVarFormParams62);
			buildParameters62.setAuthNames(localVarAuthNames62);
			buildParameters62.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters62);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalPostValidateBeforeCall(CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling seguimientoContratacionPortalPost(Async)");
        }
        return seguimientoContratacionPortalPostCall(value, authorization, progressListener, progressRequestListener);        
    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalPost(CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalPostWithHttpInfo(value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalPostWithHttpInfo(CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalPostValidateBeforeCall(value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

	/**
     * Build call for seguimientoContratacionPortalPut
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalPutCall(String id, CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody72 = value;

        
        String localVarPath72 = APIMETHOD + "{id}"
            .replace("{" + "id" + "}", apiClient.escapeString(id));

        List<Pair> localVarQueryParams72 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams72 = new ArrayList<>();

        Map<String, String> localVarHeaderParams72 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams72.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams72 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams72.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams72.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames72 = new String[] {  };
        BuildParameters buildParameters72=new BuildParameters();
			buildParameters72.setPath(localVarPath72);
			buildParameters72.setMethod("PUT");
			buildParameters72.setQueryParams(localVarQueryParams72);
			buildParameters72.setCollectionQueryParams(localVarCollectionQueryParams72);
			buildParameters72.setBody(localVarPostBody72);
			buildParameters72.setHeaderParams(localVarHeaderParams72);
			buildParameters72.setFormParams(localVarFormParams72);
			buildParameters72.setAuthNames(localVarAuthNames72);
			buildParameters72.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters72);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalPutValidateBeforeCall(String id, CSeguimientoContratacionPortalAttributes value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling seguimientoContratacionPortalPut(Async)");
        }
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling seguimientoContratacionPortalPut(Async)");
        }
        return seguimientoContratacionPortalPutCall(id, value, authorization, progressListener, progressRequestListener);

    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalPut(String id, CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalPutWithHttpInfo(id, value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param id  (required)
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalPutWithHttpInfo(String id, CSeguimientoContratacionPortalAttributes value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalPutValidateBeforeCall(id, value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

  /**
     * Build call for seguimientoContratacionPortalUploadFiles
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call seguimientoContratacionPortalUploadFilesCall(List<AttachmentData> value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody82 = value;

        
        String localVarPath82 = APIMETHOD + "uploadfiles";

        List<Pair> localVarQueryParams82 = new ArrayList<>();
        List<Pair> localVarCollectionQueryParams82 = new ArrayList<>();

        Map<String, String> localVarHeaderParams82 = new HashMap<>();
        if (authorization != null){
			localVarHeaderParams82.put(AUTH_TEXT, apiClient.parameterToString(authorization));
		}

        Map<String, Object> localVarFormParams82 = new HashMap<>();

        final String[] localVarAccepts = {
            APPJSON, TEXTJSON, TEXT_XML
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams82.put(ACCEPTTEXT, localVarAccept);

        final String[] localVarContentTypes = {
            APPJSON, TEXTJSON, TEXT_XML, URLENCODE
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams82.put(CONTENTTYPE, localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames82 = new String[] {  };
        BuildParameters buildParameters82=new BuildParameters();
			buildParameters82.setPath(localVarPath82);
			buildParameters82.setMethod("POST");
			buildParameters82.setQueryParams(localVarQueryParams82);
			buildParameters82.setCollectionQueryParams(localVarCollectionQueryParams82);
			buildParameters82.setBody(localVarPostBody82);
			buildParameters82.setHeaderParams(localVarHeaderParams82);
			buildParameters82.setFormParams(localVarFormParams82);
			buildParameters82.setAuthNames(localVarAuthNames82);
			buildParameters82.setProgressRequestListener(progressRequestListener);
		
        return apiClient.buildCall(buildParameters82);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call seguimientoContratacionPortalUploadFilesValidateBeforeCall(List<AttachmentData> value, String authorization, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        if (value == null) {
            throw new ApiException("Missing the required parameter 'value' when calling seguimientoContratacionPortalUploadFiles(Async)");
        }
        return seguimientoContratacionPortalUploadFilesCall(value, authorization, progressListener, progressRequestListener);
        

    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object seguimientoContratacionPortalUploadFiles(List<AttachmentData> value, String authorization) throws ApiException {
        ApiResponse<Object> resp = seguimientoContratacionPortalUploadFilesWithHttpInfo(value, authorization);
        return resp.getData();
    }

    /**
     * 
     * 
     * @param value  (required)
     * @param authorization JWT Token (optional)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> seguimientoContratacionPortalUploadFilesWithHttpInfo(List<AttachmentData> value, String authorization) throws ApiException {
        com.squareup.okhttp.Call call = seguimientoContratacionPortalUploadFilesValidateBeforeCall(value, authorization, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

}
